<template>
  <div class="row">
    <div class="col">

      <table-view
        :busy="isBusy"
        :name="name"
        :primary="meta.primary"
        :data="data"
        :columns="meta.attributes"
        :sort="meta.sort"
        :total="meta.total"
        :current-page="meta.current_page"
        :per-page="meta.per_page"
        :selected-rows="selectedRows"
        @all-rows-selected="onAllRowsSelected"
        @row-selected="onRowSelected"
        @row-edit-clicked="onRowEditClicked"
        @row-delete-clicked="onRowDeleteClicked"
        @context-changed="onContextChanged"
        @row-filtered="onRowFiltered"
        />

    </div>
  </div>
</template>

<script>
import { mapGetters, mapMutations } from 'vuex'
import TableView from '@/components/table-view'
import { loading, resource } from '@/mixins'
import { client } from '@/utilities'

export default {
  name: 'resource-table',

  components: { TableView },

  mixins: [loading, resource],

  data () {
    return {
      selectedRows: []
    }
  },

  computed: {
    ...mapGetters('resource', ['data', 'meta']),

    name () {
      return this.$route.name ? this.$route.name.split('.').shift() : ''
    }
  },

  watch: {
    $route (to, from) {
      this.init(to.name === from.name ? to.query : {})
    }
  },

  methods: {
    ...mapMutations('resource', ['fetching', 'fetched']),

    onAllRowsSelected (selected) {
      if (selected) {
        this.data.slice(0).forEach(this.onRowSelected)
      } else {
        this.selectedRows = []
      }
    },

    onRowSelected (item, selected) {
      const primary = item[this.meta.primary]
      if (!this.selectedRows.includes(primary) && selected) {
        this.selectedRows.push(primary)
      } else {
        this.selectedRows = this.selectedRows.filter(row => row !== primary)
      }
    },

    onContextChanged (query) {
      this.$router.push({ query })
    },

    onRowFiltered (filter) {
      this.$router.push({
        query: { filter }
      })
    },

    onRowEditClicked (item) {
      this.$router.push({
        name: `${this.name}.edit`,
        params: {
          id: item[this.meta.primary]
        }
      })
    },

    onRowDeleteClicked (item) {
      if (confirm(`Are you sure wanna delete item: ${item[this.meta.primary]}`)) {
        this.busy()

        return this.remove(item.id)
      }
      this.$router.push({
        name: `${this.name}.edit`,
        params: {
          id: item[this.meta.primary]
        }
      })
    },

    async init (params) {
      const props = {
        resource: this.name,
        type: 'index'
      }
      this.fetching(Object.assign({}, props, this.meta))

      const { data: body } = await client.get(this.name, { params })

      this.fetched({
        data: body.data,
        meta: Object.assign({}, props, body.meta)
      })
    }
  },

  async mounted () {
    await this.init()
  }
}
</script>
